/*
http://homes.cs.washington.edu/~djg/teachingMaterials/spac/sophomoricParallelismAndConcurrency.pdf#page=19
*/

import java.lang.Thread;
import java.util.Random;

class SumThread extends Thread
{
   int lo;  // fields for communicating inputs
   int hi;
   int[] arr;
   long ans = 0; // for communicating result

   SumThread(int[] a, int l, int h)
   {
      arr=a; lo=l; hi=h;
   }

   public void run()  // overriding, must have this type
   {
      for (int i = lo; i < hi; i++)
      {
         ans += arr[i];
      }
   }
}


class C
{
   static long sum(int[] arr, int numThreads)
   {
      int len = arr.length;
      long ans = 0;
      SumThread[] ts = new SumThread[numThreads];

      for (int i = 0; i < numThreads; i++)
      {
         ts[i] = new SumThread(arr,(i*len)/numThreads,((i+1)*len)/numThreads);
         ts[i].start();
      }

      for (int i = 0; i < numThreads; i++)
      {
         try
         {
            ts[i].join();
         }
         catch (java.lang.InterruptedException e){}
         ans += ts[i].ans;
      }
      return ans;
   }
}


public class Section_3_2
{
   public static final int PROBLEM_SIZE = 100_000_000;
   public static int numbers[] = new int[PROBLEM_SIZE];

   public static void main(String[] args)
   {
      Random generator = new Random();
      for (int i = 0; i < numbers.length; i++)
         numbers[i] = generator.nextInt(40);

      long startTime;
      long stopTime;

      startTime = System.currentTimeMillis();
         long result = C.sum(numbers, 2);
      stopTime = System.currentTimeMillis();
      System.out.println("Parallel sum: " + result);
      System.out.println("Parallel solution time: " + (stopTime - startTime));

      result = 0;
      startTime = System.currentTimeMillis();
        for (int i = 0; i < numbers.length; ++i)
           result += numbers[i];
      stopTime = System.currentTimeMillis();
      System.out.println("Sequential sum: " + result);
      System.out.println("Sequential solution time: " + (stopTime - startTime));
   }
}
