
// Pseudo-code for Fork/Join parallelism.

Result solve(Problem problem)
{
   if (problem.size < SEQUENTIAL_THRESHOLD)
   {
      return solveSequentially(problem);
   {
   else
   {
      Problem left = extractLeftHalf(problem);
      Problem right = extractRightHalf(problem);

      left.fork();                     // kind of like recursion
      Result rightAns = right.solve(); // recursion

      Result leftAns = left.join();

      return combine(leftAns, rightAns);
   }
}


// Notice that Fork/Join parallelism is essentially
///the divide-and-conquer approach to algorithm design.

// Here is what a pure divide-and-conquer algorithm looks like.

Result solve(Problem problem)
{
   if (problem.size < SEQUENTIAL_THRESHOLD)
   {
      return solveSequentially(problem);
   {
   else
   {
      Problem left = extractLeftHalf(problem);
      Problem right = extractRightHalf(problem);

      Result  leftAns =  left.solve();  // recursion
      Result rightAns = right.solve();  // recursion

      return combine(leftAns, rightAns);
   }
}
